(dp 优化)洛谷 P14460 寻雾启示 题解

题意

题目传送门,建议前往原题阅读题面、样例及其解释。

思路

设 f i f_i fi 表示走到位置 i i i 的最小话费。发现从起点开始能走多远,取决于在 0 0 0 处拿了多少铁,为了不浪费时间,每次回到 0 0 0、从 0 0 0 出发都只拿到达现阶段要到达的终点所需的铁。

那么显然有初始化 f i = i × ( k + t 1 ) f_i=i\times (k+t_1) fi=i×(k+t1)。

考虑转移,考虑前面某个阶段终点为 j j j 用完了所有的铁,现在想 j → 0 → i j\to 0\to i j→0→i。那么要从 j j j 走回 0 0 0 并且等到刷新出 i i i 块铁,然后以 t 2 t_2 t2 速度走到 j j j 在以 t 1 t_1 t1 速度走到 i i i,即:
f i ← max ⁡ ( f j + j × t 2 , i × k ) + j × t 2 + ( i − j ) × t 1 f_i\leftarrow \max(f_j+j\times t_2,i\times k)+j\times t_2+(i-j)\times t_1 fi←max(fj+j×t2,i×k)+j×t2+(i−j)×t1

为什么没有转移 f i ← f i − 1 + k + t 1 f_i\leftarrow f_{i-1}+k+t_1 fi←fi−1+k+t1 呢?因为走到 i − 1 i-1 i−1 不一定是从起点直接走到 i − 1 i-1 i−1,可能这段时间不足以刷新出一块石头,于是不能粗暴地加。

时间复杂度 O ( n 2 ) O(n^2) O(n2),然后就拿到了 90pts。

代码1(90pts,TLE*1)

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll N=1e5+9,inf=0x3f3f3f3f;
ll Q,n,k,t1,t2;
ll f[N];//设走到i,不剩石头最优 
int main()
{
	scanf("%lld",&Q);
	memset(f,inf,sizeof(f));
	while(Q--)
	{
		scanf("%lld%lld%lld%lld",&n,&k,&t1,&t2);
		f[1]=k+t1;
		for(int i=2;i<=n;i++)
		{
			f[i]=i*k+i*t1;
			for(int j=1;j<i;j++)
			{
				f[i]=min(f[i],max(f[j]+j*t2,i*k)+j*t2+(i-j)*t1);
			}
		}
		for(int i=1;i<=n;i++)
		{
			printf("%lld ",f[i]);
			f[i]=inf;
		}
		puts("");
	}
	return 0;
}

考虑优化,发现 f i f_i fi 必然是单调递增的,而对于 j → 0 → i j\to 0\to i j→0→i 这个过程, j j j 越大这个过程就越长。于是考虑维护一个最优上一转移点(上一阶段终点) b e s bes bes,对于 j ∈ [ b e s , i ) j\in[bes,i) j∈[bes,i) 尝试 j → 0 → i j\to 0\to i j→0→i 更新 f i f_i fi 和 b e s bes bes,如果遇到一个 > f i >f_i >fi 的 j j j,那么后面的 j j j 都不优了,直接 break 掉。

不必探讨 b e s bes bes 前面的点了,因为选前面的点就会使 j × ( t 2 − t 1 ) j\times (t_2-t_1) j×(t2−t1) 的 j j j 变小, t 1 t_1 t1 远小于 t 2 t_2 t2 的情况已经涵盖在初始化 f i = i × k + i × t 1 f_i=i\times k+i\times t_1 fi=i×k+i×t1 了,所以此处 t 1 t_1 t1 远大于 t 2 t_2 t2,即 j j j 越小 j × ( t 2 − t 1 ) j\times (t_2-t_1) j×(t2−t1) 越大。并且你的 j j j 再小也得和 i × k i\times k i×k 取 max ⁡ \max max。

所以均摊下来是 O ( n ) O(n) O(n) 的。

代码

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ls u<<1
#define rs u<<1|1
const ll N=1e5+9,inf=0x3f3f3f3f;
ll Q,n,k,t1,t2;
ll f[N],g[N];//设走到i,不剩石头最优 
int main()
{
	scanf("%lld",&Q);
	while(Q--)
	{
		scanf("%lld%lld%lld%lld",&n,&k,&t1,&t2);
		f[1]=k+t1;
		ll bes=0;
		for(int i=2;i<=n;i++)
		{
			f[i]=i*k+i*t1;
			for(int j=max(bes,1ll);j<i;j++)
			{
				ll tem=max(f[j]+j*t2,i*k)+j*t2+(i-j)*t1;
				if(tem<f[i])
				{
					f[i]=tem;
					bes=j;
				}
				else break;
			}
		}
		for(int i=1;i<=n;i++)
		{
			printf("%lld ",f[i]);
		}
		puts("");
	}
	return 0;
}
相关推荐
Nil2084 小时前
leetcode 198打家劫舍
算法·leetcode·职场和发展
Shaoshing4 小时前
前缀和与差分
java·数据结构·算法·前缀和·差分
loulanyue_5 小时前
构建房产认知决策智能:Harness底座与AI自进化的技术实践——读贝壳首席算法科学家尹俊希2026云栖专场演讲
人工智能·算法
碧海银沙音频科技研究院5 小时前
基于炬芯ATS录音卡BLE控制协议
人工智能·嵌入式硬件·算法·语音识别
suhan5 小时前
【数据结构】三、栈和队列:6.链队列、双端队列、队列的应用(树的层次遍历、广度优先BFS、先来先服务FCFS)
数据结构·后端·算法
姜鱼问生6 小时前
Docker Volume 备份与恢复实战:不停机迁移数据
后端·算法·架构
suhan6 小时前
【数据结构】三、栈和队列:5.顺序队列(循环队列)(初始化,判空判满,入队,出队,实例)
数据结构·后端·算法
suhan6 小时前
【数据结构】三、栈和队列:3.链栈(链栈栈的初始化,判空,进栈,出栈,读取栈顶,链栈实例)
数据结构·后端·算法
大雄很用心6 小时前
如何理解时间复杂度与空间复杂度?| 面试刷题笔记02
算法
姜鱼问生6 小时前
服务器磁盘满了?从告警到清理的完整排查
后端·算法·架构